<?php
interface _DB_driver
{
    public function query($sql, $data = array());
    public function getCount ();
}

class DB_driver extends PDO implements _DB_driver 
{
    protected $count = 0;
    protected $opt = array(
        PDO::ATTR_PERSISTENT         => TRUE,
        PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_LAZY,
        PDO::ATTR_ERRMODE            => PDO::ERRMODE_EXCEPTION
    );
    
    public function __construct ()
    {
        $cfg=pul::get('config');
        try 
        {
            parent::__construct('mysql:host='.$cfg->get('db_host', 'database').';
            dbname='.$cfg->get('db_name', 'database').';', $cfg->get('db_user', 'database'), 
                                $cfg->get('db_pass', 'database'), $this->opt);
        }
        catch (PDOException $e) 
        {
            print 'Error!: '.$e->getMessage();
            exit();
        }
    }
    
    public function query ($sql, $data = array())
    {
        if (empty($data))
        {
            $query = parent::query($sql);
            if ($query)
            {
                $this->count++;
                return $query;
            }
            else
            {
                return FALSE;
            }
        }
        else
        {
            if ($stmt = parent::prepare($sql))
            {
                $this->count++;
                $stmt -> execute($data);
                return $stmt;
            }
            else
            {
                return FALSE;
            }
        }
    }
    
    public function getCount()
    {
        return $this->count;
    }
}