<?php
function show_404()
{
    ob_end_clean();
    if (file_exists(application_folder.'/errors/404.php'))
    {
        include_once(application_folder.'/errors/404.php');
    }
    else
    {
        exit('Error: 404');
    }
}

function encode_php_tags($str)
{
    return str_replace(array('<?php', '<?PHP', '<?', '?>'),  array('&lt;?php', '&lt;?PHP', '&lt;?', '?&gt;'), $str);
}

function xss_clean ($var)
{
    if (is_array($var))
    {
        foreach ($var as $name => $value)
        {
            $var[$name] = encode_php_tags(html_escape($value));
        }
        return $var;
    }
    else
    {
        return encode_php_tags(html_escape($var));
    }
}

function show_error ($message, $heading = 'An Error Was Encountered')
{
    ob_end_clean();
    if (file_exists(application_folder.'/errors/show_error.php'))
    {
        include_once(application_folder.'/errors/show_error.php');
    }
    else
    {
        exit($message);
    }
}

function load_class ($name, $dir)
{
    if (file_exists(system_folder.'/'.$dir.'/'.$name.'.php'))
    {
        include_once(system_folder.'/'.$dir.'/'.$name.'.php');
        return new $name();
    }
    else
    {
        show_error('Error: '.$name);
    }
}

function html_escape($var)
{
    if (is_array($var))
    {
        foreach ($var as $in => $val)
        {
            $var[$in] = htmlspecialchars($val);
        }
        return $var;
    }
    else
    {
        return htmlspecialchars($var, ENT_QUOTES, config_item('charset'));
    }
}


function &get_config($file='config')
{
    static $_config;

    if (isset($_config))
    {
	   return $_config[0];
    }

    if (file_exists(application_folder.'/config/'.$file.'.php'))
    {
        $file_path = application_folder.'/config/'.$file.'.php';
    }
    else
    {
        exit('The configuration file does not exist.');
    }

    require($file_path);
    
    if (!isset($config) OR !is_array($config))
    {
        exit('Your config file does not appear to be formatted correctly.');
    }

    $_config[0] =& $config;
    return $_config[0];
}

function config_item($item, $file = 'config')
{
    static $_config_item = array();

    if ( ! isset($_config_item[$item]))
    {
        $config =& get_config($file);
        if ( ! isset($config[$item]))
        {
            return FALSE;
        }
        $_config_item[$item] = $config[$item];
    }

    return $_config_item[$item];
}